unit MainForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Vcl.Grids, AdvObj, BaseGrid, AdvGrid, Vcl.StdCtrls,
  Vcl.Samples.Spin, vcl.graphics;

type
  TMainfrm = class(TForm)
    SpinEdit: TSpinEdit;
    Grid: TAdvStringGrid;
    procedure FormActivate(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
    procedure GridGetAlignment(Sender: TObject; ARow, ACol: Integer; var HAlign: TAlignment; var VAlign: TVAlignment);
    procedure GridGetCellColor(Sender: TObject; ARow, ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);
  private
    procedure FillGrid(Grid: TAdvStringGrid);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Mainfrm: TMainfrm;

implementation

{$R *.dfm}

procedure TMainfrm.SpinEditChange(Sender: TObject);
var
  r, c: integer;

begin
  //Perhaps this is not the reommended way of changing cell font sizes, but if so, why is it included in the code base?
  Grid.Font.Size := Trunc(SpinEdit.Value);
  for r := 0 to Grid.RowCount do
    for c := 0 to Grid.ColCount do
      Grid.Fonts[c, r].Size := Trunc(SpinEdit.Value);
  Grid.AutoSizeColumns(true);
  Grid.AutoSizeRows(true);
end;

procedure TMainfrm.FillGrid(Grid: TAdvStringGrid);

var
  row, g, r, c: integer;

begin
  Grid.ColCount := 13;
  Grid.RowCount := 11;
  Grid.FixedCols := 2;
  Grid.FixedRows := 2;
  Grid.Cells[1, 0] := 'Row';
  for c := 1 to 13 do
    Grid.Cells[c, 0] := Format('Column %d', [c]);
  row := 1;
  for r := 1 to 10 do
    begin
      Grid.Cells[0, row] := Format('Row %d', [r]);
      for c := 1 to 13 do
        begin
          Grid.Cells[c, row] := FloatToStrF(Random(10), ffFixed, 15, 2);
          //if you set any alignment values then grid does not properly handle changes to font size (either by setting grid.font.size or by setting grid.fonts[c,r]
          //comment out the following line and you can then change font sizes.
          //if its here then changuing font size only seems to change fixed font sizes
          Grid.Alignments[c, row] := taRightJustify;
        end;
      Inc(row);
    end;
end;

procedure TMainfrm.FormActivate(Sender: TObject);

begin
  FillGrid(Grid);
end;

procedure TMainfrm.GridGetAlignment(Sender: TObject; ARow, ACol: Integer; var HAlign: TAlignment; var VAlign: TVAlignment);
begin
//  if ACol > 0 then
//    HAlign :=  taRightJustify;
end;


procedure TMainfrm.GridGetCellColor(Sender: TObject; ARow, ACol: Integer; AState: TGridDrawState; ABrush: TBrush; AFont: TFont);

//If you change colors/fonts this way via events it DOES seem to work.

begin
//  if (ACol > 0) and (ARow > 0) then
//    Afont.Color := clgreen
//  else
//    Afont.Color := clred;
//
//  if (ACol > 3) and (ARow > 3) then
//    begin
//      Abrush.Color := clyellow;
//      Afont.Name :=   'Papyrus';
//      Afont.Style := [fsBold, fsItalic];
//    end
//  else
//    begin
//     Abrush.Color := clwindow;
//     Afont.Name :=   'Segoe UI';
//    end;
end;

end.
